# fastapi
from fastapi import FastAPI, Request, Response, HTTPException
from fastapi import templating
from fastapi.templating import Jinja2Templates
from fastapi.responses import HTMLResponse, RedirectResponse, JSONResponse
from fastapi.middleware.cors import CORSMiddleware

# static file
from fastapi.staticfiles import StaticFiles

# fastapi view function parameters
from typing import List, Optional

# path
import os

# time
import datetime

# db
import dataset
from passlib import context

# authorize
from passlib.context import CryptContext
# from jose import JWTError, jwt
from fastapi_jwt_auth import AuthJWT
from fastapi_jwt_auth.exceptions import AuthJWTException
from fastapi.security import OAuth2AuthorizationCodeBearer, OAuth2PasswordRequestForm


# app
app = FastAPI()



# 
app.mount(path='/templates', app=StaticFiles(directory='templates'), name='templates')
app.mount(path='/static', app=StaticFiles(directory='static'), name='static ')



# 
templates = Jinja2Templates(directory='templates')

# view
@app.get('/', response_class=HTMLResponse)
async def index(request: Request):
    print(request)
    return templates.TemplateResponse(name='index.html', context={'request': request})


# @app.get('/make_video', response_class=HTMLResponse)
# async def index(request: Request):
#     print(request)
#     return templates.TemplateResponse(name='make_video.html', context={'request': request})

@app.get('/login', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='login.html', context={'request': request})

@app.get('/home', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='home.html', context={'request': request})

@app.get('/monitor/tower', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='home.html', context={'request': request})

@app.get('/optim', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='optim.html', context={'request': request})

@app.get('/monotor/vibration', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='vibration.html', context={'request': request})

@app.get('/history', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='history.html', context={'request': request})

@app.get('/set_up/device', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='device.html', context={'request': request})

@app.get('/set_up/system', response_class=HTMLResponse)
async def login(request: Request):
    return templates.TemplateResponse(name='system.html', context={'request': request})